
$fname=$ARGV[0];
$outf=$ARGV[0];
$outf=~s/\.\w+/.as/;

open (inp, "$fname");
open (of, ">$outf");

while (<inp>) {
    if (m/^;/) {
        print of "$_";
    }
    else {

            undef $p;
	    undef $c;

	    P: {
		undef $m;
                $m=$+ if (s/^(\s*|\t*)([A-Z,a-z,0-9,_,.]+)//);
                undef $l;
		last P if (!defined($m));
                if ($m=~s/^list$/*List ON/) {
                        last P;
                }
                if ($m=~s/^nolist$/*List OFF/) {
                        last P;
                }
                if ($m=~s/^read$/*Include/) {
                        s/^(\s+|\t+)\"(.+)\"//;
			$l=$2;
			$l=~s/(.*)\.z/$1.as/;
                        $m="$m $l";
			undef $l;
                        last P;
                }
                last P if ($m=~s/^if$/\IF/);
                last P if ($m=~s/^endif$/\ENDC/);
                last P if ($m=~s/^else$/\ELSE/);
                if ($m=~s/^\.(\w+)$//) {
                        $l=$+;
			undef $m;
                        $m=$+ if (s/^(\s*|\t*)(\w+)//);
                }
                elsif (s/^(\s*|\t*)equ(\s+|\t+)//) {
                        $l=$m;
                        $m="EQU";
                        last P;
                }
                $m=~s/^defb$/db/;
                $m=~s/^defs$/ds/;
                $m=~s/^defw$/dw/;
		$m=~s/^org$/ORG/;
		last P ;
            }

        X:
	 while (!(m/^(\s*|\t*)$/))
	 {
            undef $x;
            if (s/^(\s*|\t*)(\d+)//) {
                $x=$+;
            }
            elsif (s/^(\s*|\t*)\&([A-F,a-f,0-9]+)//) {
                $x="0x$+";
            }

            elsif (s/^(\s+|\t+)(and)(\s+|\t+)//) {
                $p="$p .and. ";
            }
            elsif (s/^(\s+|\t+)(or)(\s+|\t+)//) {
                $p="$p .or. ";
            }
            elsif (s/^(\s+|\t+)(not)(\s+|\t+)//) {
                $p="$p .not. ";
            }

            elsif (s/^(\s*|\t*)(\w+)//) {
                $x=$+;
            }

            elsif (s/^(\s*|\t*)(".*")//) {
                $x=$+;
            }

            elsif (s/^(\s*|\t*)'(.)'//) {
                $x="\"$+\"";
            }

            elsif (m/^(\s*|\t*);(.*)$/) {
                $c=";$+";
		last X;
            }

            elsif (s/^(\s*|\t*)(.)//) {
                $x=$+;
                if ($p=~m/(\w|\)|\s)$/) {
                        $p="$p$x";
                }
                else {
                        $p="$p $x";
                }
                undef $x;
            }

            if (defined($x)) {
                if ($p=~m/[\+\-\/\*|%\&!(\s]$/) {
                        $p="$p$x";
                }
                else {
                        $p="$p $x";
                }
            }

        }

	$l=~s/^NUL$/NUL_/ if (defined($l));
        $p=~s/(\W|^)NUL(\W|$)/$1NUL_$2/ if (defined($p));

	if (defined($l)) {
        	print of "$l\:\t" if ($m ne "EQU");
		print of "$l\t" if ($m eq "EQU");
        	print of "\t" if (length($l)<8);
	} else {
                print of "\t" if (!($m=~m/^\*/));
	}
        print of "$m $p";
	if (defined($c)) {
		print of "\t";
		print of "\t" if ((length($p)+length($m))<7);
		print of "$c";
	}
	print of "\n";


    }
}

close inp;
close of;
exit 0;